<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes" />
<xsl:param name = "export_proxy_class_id" />
<xsl:template match="/">
import time
import threading
import signal
import sys
import py_nerv as nerv
from py_nerv import Data as nstt # Nerv struct
import py_nerv_print_data as nprint
import py_nerv_set_data as nset

  <xsl:for-each select="/nerv_icde/component/proxy_list/row[id=$export_proxy_class_id]">
    <xsl:variable name="method_domain_id" select="method_domain_id" />
    <xsl:variable name="interface_name" select="interface_name" />
    <xsl:variable name="class_name" select="class_name" />
class <xsl:value-of select="class_name"/>(nerv.<xsl:value-of select="class_name"/>):

    def on_object_create(self):
        print("<xsl:value-of select="$class_name"/>::on_object_create()")
        print(flush=True)
        connect_timeout = 1.0
    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:if test="type='COMMAND' or type='EVENT' or type='INFORMATION'">
        err = self.<xsl:value-of select="name"/>_connect(<xsl:if test="type='INFORMATION'">True, </xsl:if> connect_timeout, None )
        print("<xsl:value-of select="$class_name"/>::<xsl:value-of select="name"/>_connect() = ", err )
            </xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
<xsl:text>
        </xsl:text>pass

    def on_object_destroy(self):
        print("<xsl:value-of select="$class_name"/>::on_object_destroy()")
        print(flush=True)
        pass

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:choose>
              <xsl:when test="type='EVENT'">
    def on_<xsl:value-of select="$method_name"/>_disconnected(self):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_disconnected()")
        print(flush=True)
        return 0
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>(self, _elapsed_time):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>()")
        print(flush=True)
        pass
                  </xsl:when>
                  <xsl:otherwise>
    def on_<xsl:value-of select="$method_name"/>(self, _evt_data_, _elapsed_time):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>()")
        nprint.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(_evt_data_)
        pass
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>

              <xsl:when test="type='COMMAND'">
    def on_<xsl:value-of select="$method_name"/>_disconnected(self):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_disconnected()")
        print(flush=True)
        pass
              </xsl:when>


              <xsl:when test="type='INFORMATION'">
    def on_<xsl:value-of select="$method_name"/>_disconnected(self):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_disconnected()")
        print(flush=True)
        pass
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>_sync(self, _sync_model, _elapsed_time, _limit_time):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_sync()")
        print(flush=True)
        pass
                  </xsl:when>
                  <xsl:otherwise>
    def on_<xsl:value-of select="$method_name"/>_sync(self, _sync_model, _elapsed_time, _limit_time, _inf_data_):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_sync(%d , %lf, %f)" % ( _sync_model , _elapsed_time, _limit_time ) )
        nprint.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(_inf_data_)
        print(flush=True)
        pass
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>

              <xsl:when test="type='BROADCAST'">
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
    def on_<xsl:value-of select="$method_name"/>_broadcast(self, _proxy_addr, _elapsed_time):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_broadcast()")
        print(flush=True)
        pass
                  </xsl:when>
                  <xsl:otherwise>
    def on_<xsl:value-of select="$method_name"/>_broadcast(self, _proxy_addr, _dtg_data_, _elapsed_time):
        print("<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_broadcast()")
        nprint.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(_dtg_data_)
        print(flush=True)
        pass
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>

</xsl:template>


</xsl:stylesheet>
