<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes" />
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
import time
import threading
import signal
import sys
import py_nerv as nerv
from py_nerv import Data as nstt # Nerv struct
import py_nerv_print_data as nprint
import py_nerv_set_data as nset

  <xsl:for-each select="/nerv_icde/component/stub_list/row">
from <xsl:value-of select="class_name"/> import <xsl:value-of select="class_name"/>
  </xsl:for-each>
  <xsl:for-each select="/nerv_icde/component/proxy_list/row">
from <xsl:value-of select="class_name"/> import <xsl:value-of select="class_name"/>
  </xsl:for-each>

class <xsl:value-of select="$component_name"/>():

    def __init__(self):
        print("<xsl:value-of select="$component_name"/>.__init__()")
        self.a = 0

        # create 전에 모든 객체를 생성해야 합니다.
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
<xsl:text>
        </xsl:text>self.stub_<xsl:value-of select="object_name"/> = <xsl:value-of select="../../class_name"/>()<xsl:text/>
  </xsl:for-each>
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
<xsl:text>
        </xsl:text>self.proxy_<xsl:value-of select="object_name"/> = <xsl:value-of select="../../class_name"/>()<xsl:text/>
  </xsl:for-each>
        pass

    def proxy_read(self):

  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="out_data_domain_id" select="out_data_domain_id"/>
            <xsl:variable name="out_data" select="out_data"/>
            <xsl:variable name="in_data_domain_id" select="in_data_domain_id"/>
            <xsl:variable name="in_data" select="in_data"/>
            <xsl:variable name="in_domain_namespace_dot">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_domain_namespace_dot">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:if test="type='INFORMATION' and out_data!='(null)'">
              <xsl:variable name="data"><xsl:value-of select="$out_data"/></xsl:variable>
<xsl:text>

        </xsl:text><xsl:value-of select="$data"/> = nstt<xsl:value-of select="$out_domain_namespace_dot"/>.<xsl:value-of select="out_data"/>()<xsl:text/>
<xsl:text>
        err = self.proxy_</xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_read(<xsl:value-of select="$data"/>)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_read() = ", nerv.get_err_str(err))
        if not err:
            nprint.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(<xsl:value-of select="out_data"/>)
            print(flush=True)<xsl:text/>
            </xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
        pass

    def stub_send(self):
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="out_data_domain_id" select="out_data_domain_id"/>
            <xsl:variable name="out_data" select="out_data"/>
            <xsl:variable name="in_data_domain_id" select="in_data_domain_id"/>
            <xsl:variable name="in_data" select="in_data"/>
            <xsl:variable name="in_domain_namespace_dot">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_domain_namespace_dot">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:if test="(type='EVENT' or type='INFORMATION' or type='BROADCAST') and out_data!='(null)'">
              <xsl:variable name="data"><xsl:value-of select="$out_data"/></xsl:variable>
<xsl:text>

        </xsl:text><xsl:value-of select="$data"/> = nstt<xsl:value-of select="$out_domain_namespace_dot"/>.<xsl:value-of select="out_data"/>()<xsl:text/>
        nset.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(<xsl:value-of select="$data"/>, self.a)
              <xsl:choose>
                <xsl:when test="type='EVENT'">
                  <xsl:if test="out_data='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>()
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>() = ", nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                  <xsl:if test="out_data!='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(<xsl:value-of select="$data"/>)
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>() = ", nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                </xsl:when>
                <xsl:when test="type='INFORMATION'">
                  <xsl:if test="out_data='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write()
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write() = ", nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                  <xsl:if test="out_data!='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write(<xsl:value-of select="$data"/>)
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write() = ", nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                </xsl:when>
                <xsl:when test="type='BROADCAST'">
                  <xsl:if test="out_data='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_broadcast()
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_broadcast() = ", nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                  <xsl:if test="out_data!='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_broadcast(<xsl:value-of select="$data"/>)
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_broadcast() = ", nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                </xsl:when>
              </xsl:choose>
        nprint.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(<xsl:value-of select="$data"/>)
        print(flush=True)<xsl:text/>
            </xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
        pass

    def proxy_send(self):
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="in_domain_namespace_dot">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_domain_namespace_dot">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="type='CALL'">
                <xsl:if test="in_data='(null)' and out_data='(null)'">
<xsl:text>

        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>( 1.0, None)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>() = ", nerv.get_err_str(err) )<xsl:text/>
                </xsl:if>
                <xsl:if test="in_data!='(null)' and out_data='(null)'">
                  <xsl:variable name="data">in_data_<xsl:value-of select="position()"/></xsl:variable>
<xsl:text>

        </xsl:text><xsl:value-of select="$data"/> = nstt<xsl:value-of select="$in_domain_namespace_dot"/>.<xsl:value-of select="in_data"/>()<xsl:text/>
        nset.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(<xsl:value-of select="$data"/>, self.a)
<xsl:text>

        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(<xsl:value-of select="$data"/>, 1.0, None )
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>() = ", nerv.get_err_str(err) )
                </xsl:if>
                <xsl:if test="in_data='(null)' and out_data!='(null)'">
                  <xsl:variable name="data">out_data_<xsl:value-of select="position()"/></xsl:variable>
<xsl:text>

        </xsl:text><xsl:value-of select="$data"/> = nstt<xsl:value-of select="$out_domain_namespace_dot"/>.<xsl:value-of select="out_data"/>()<xsl:text/>
<xsl:text>
        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(<xsl:value-of select="$data"/>, 1.0, None)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>() = ", nerv.get_err_str(err) )
        nprint.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(<xsl:value-of select="out_data"/>)<xsl:text/>
                </xsl:if>
                <xsl:if test="in_data!='(null)' and out_data!='(null)'">
                  <xsl:variable name="in_data">in_data_<xsl:value-of select="position()"/></xsl:variable>
                  <xsl:variable name="out_data">out_data_<xsl:value-of select="position()"/></xsl:variable>
<xsl:text>

        </xsl:text><xsl:value-of select="$in_data"/> = nstt<xsl:value-of select="$in_domain_namespace_dot"/>.<xsl:value-of select="in_data"/>()<xsl:text/>
        nset.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(<xsl:value-of select="$in_data"/>, self.a)
<xsl:text>
        </xsl:text><xsl:value-of select="$out_data"/> = nstt<xsl:value-of select="$out_domain_namespace_dot"/>.<xsl:value-of select="out_data"/>()<xsl:text/>
<xsl:text>
        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(<xsl:value-of select="$in_data"/>, <xsl:value-of select="$out_data"/> , 1.0, None)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>() = ", nerv.get_err_str(err) )
        nprint.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(<xsl:value-of select="out_data"/>)<xsl:text/>
                </xsl:if>
              </xsl:when>
              <xsl:when test="type='SIGNAL'">
                <xsl:if test="in_data='(null)'">
<xsl:text>

        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>( 1.0, None)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>() = ", nerv.get_err_str(err) )<xsl:text/>
                </xsl:if>
                <xsl:if test="in_data!='(null)'">
                  <xsl:variable name="data">in_data_<xsl:value-of select="position()"/></xsl:variable>
<xsl:text>

        </xsl:text><xsl:value-of select="$data"/> = nstt<xsl:value-of select="$in_domain_namespace_dot"/>.<xsl:value-of select="in_data"/>()<xsl:text/>
        nset.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(<xsl:value-of select="$data"/>, self.a)
<xsl:text>
        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(<xsl:value-of select="$data"/>, 1.0, None)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>() = ", nerv.get_err_str(err) )<xsl:text/>
                </xsl:if>
              </xsl:when>
              <xsl:when test="type='COMMAND'">
                <xsl:if test="in_data='(null)'">
<xsl:text>

        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write()
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write() = ", nerv.get_err_str(err) )<xsl:text/>
                </xsl:if>
                <xsl:if test="in_data!='(null)'">
                  <xsl:variable name="data">in_data_<xsl:value-of select="position()"/></xsl:variable>
<xsl:text>

        </xsl:text><xsl:value-of select="$data"/> = nstt<xsl:value-of select="$in_domain_namespace_dot"/>.<xsl:value-of select="in_data"/>()<xsl:text/>
        nset.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(<xsl:value-of select="$data"/>, self.a)
<xsl:text>
        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write(<xsl:value-of select="$data"/>)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write() = ", nerv.get_err_str(err) )<xsl:text/>
                </xsl:if>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
        pass

    def Start(self):
        print("<xsl:value-of select="$component_name"/>.Start()")

        # 모든 객체를 생성한 이후에 create 할수 있습니다.

        # stub 객체 생성
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
<xsl:text>
        </xsl:text>port = nerv.get_<xsl:value-of select="../../method_domain_name"/>_port()<xsl:text/>
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="object_name"/>.create(port, <xsl:value-of select="position()"/>)<xsl:text/>
  </xsl:for-each>

        # proxy 객체 생성
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
<xsl:text>
        </xsl:text>port = nerv.get_<xsl:value-of select="../../method_domain_name"/>_port()
        ip = nerv.inet_addr("127.0.0.1")
        obj_id = 1
        err = self.proxy_<xsl:value-of select="object_name"/>.create(port, ip, obj_id, 0 )<xsl:text/>
  </xsl:for-each>
        pass

    def Update(self):
        print("<xsl:value-of select="$component_name"/>.Update()")
        self.a = self.a + 1
        self.a = self.a % 8

        self.proxy_read()

        self.proxy_send()

        self.stub_send()

        pass

if __name__ == '__main__':

    # 객체를 생성하기 전에 nerv 라이브러리를 초기화 해야 합니다.
    nerv.initialize()

    <xsl:value-of select="$component_name"/> = <xsl:value-of select="$component_name"/>()

    <xsl:value-of select="$component_name"/>.Start()

    a = 0
    # main loop
    while True:
        time.sleep(1)
        <xsl:value-of select="$component_name"/>.Update()

    nerv.finalize()
</xsl:template>
</xsl:stylesheet>
