<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../../xsl_util.xsl"/>

<xsl:output method="text" encoding="utf-8" indent="yes"/>

<xsl:param name = "export_proxy_class_id" />

<xsl:template match="/">
  <xsl:for-each select="/nerv_icde/component/proxy_list/row[id=$export_proxy_class_id]">
    <xsl:variable name="method_domain_id" select="method_domain_id" />
    <xsl:variable name="interface_name" select="interface_name" />
    <xsl:variable name="class_name" select="class_name" />

#include "<xsl:value-of select="$class_name"/>.h"

::<xsl:value-of select="$class_name"/>::<xsl:value-of select="$class_name"/>()
{
}

::<xsl:value-of select="$class_name"/>::~<xsl:value-of select="$class_name"/>()
{
}

Nerv::nerv_err_t ::<xsl:value-of select="$class_name"/>::create( Nerv::domain_t _domain, Nerv::ip_t _server_ip, Nerv::object_id_t _object_id , Nerv::object_id_t _proxy_object_id )
{
    Nerv::nerv_err_t ret;
    Py_BEGIN_ALLOW_THREADS
    ret = Nerv::nerv_proxy_object::create( _domain, _server_ip, _object_id , _proxy_object_id);
    Py_END_ALLOW_THREADS
    return ret;
}

Nerv::nerv_err_t ::<xsl:value-of select="$class_name"/>::destroy()
{
    Nerv::nerv_err_t ret;
    Py_BEGIN_ALLOW_THREADS
    ret = Nerv::nerv_proxy_object::destroy();
    Py_END_ALLOW_THREADS
    return ret;
}

//
//
//
//

void ::<xsl:value-of select="$class_name"/>::on_object_create()
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_object_create")();
    PyGILState_Release(state);
}

void ::<xsl:value-of select="$class_name"/>::on_object_destroy()
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_object_destroy")();
    PyGILState_Release(state);
}

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">

            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="type='CALL'">
//
//
//
//
//
//
              </xsl:when>
              <xsl:when test="type='SIGNAL'">
//
//
//
//
//
//
              </xsl:when>
              <xsl:when test="type='EVENT'">
//
//
//
//
//
//

void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_disconnected()
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_disconnected")();
    PyGILState_Release(state);
}
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>(double _elapsed_time)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>")(_elapsed_time);
    PyGILState_Release(state);
}
                  </xsl:when>
                  <xsl:otherwise>
void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>(const Nerv::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _evt_dat_,  double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>")(boost::ref(_evt_dat_), _elapsed);
    PyGILState_Release(state);
}
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>


              <xsl:when test="type='COMMAND'">
//
//
//
//
//
//

void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_disconnected()
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_disconnected")();
    PyGILState_Release(state);
}
              </xsl:when>


              <xsl:when test="type='INFORMATION'">
//
//
//
//
//
//

void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_disconnected()
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_disconnected")();
    PyGILState_Release(state);
}
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_sync( Nerv::sender_sync_model_t _sync_model, double _elapsed, double _limit )
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_sync")(_sync_model, _elapsed, _limit);
    PyGILState_Release(state);
}
                  </xsl:when>
                  <xsl:otherwise>
void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_sync( Nerv::sender_sync_model_t _sync_model, double _elapsed, double _limit, const Nerv::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _inf_dat_)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_sync")(_sync_model, _elapsed, _limit, boost::ref(_inf_dat_));
    PyGILState_Release(state);
}
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>


              <xsl:when test="type='BROADCAST'">
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_broadcast( ::Nerv::server_addr_t _server, double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_broadcast")(_server, _elapsed);
    PyGILState_Release(state);
}
                  </xsl:when>
                  <xsl:otherwise>
void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_broadcast(::Nerv::server_addr_t _server, const Nerv::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _bst_dat_, double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_broadcast")(_server, boost::ref(_bst_dat_), _elapsed);
    PyGILState_Release(state);
}
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
</xsl:template>

</xsl:stylesheet>
