<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../../xsl_util.xsl"/>

<xsl:output method="text" encoding="utf-8" indent="yes"/>

<xsl:param name = "export_stub_class_id" />

<xsl:template match="/">
  <xsl:for-each select="/nerv_icde/component/stub_list/row[id=$export_stub_class_id]">
    <xsl:variable name="method_domain_id" select="method_domain_id" />
    <xsl:variable name="interface_name" select="interface_name" />
    <xsl:variable name="class_name" select="class_name" />

#include "<xsl:value-of select="$class_name"/>.h"

::<xsl:value-of select="$class_name"/>::<xsl:value-of select="$class_name"/>()
{
}

::<xsl:value-of select="$class_name"/>::~<xsl:value-of select="$class_name"/>()
{
}

Nerv::nerv_err_t ::<xsl:value-of select="$class_name"/>::create( Nerv::domain_t _domain, Nerv::object_id_t _object_id )
{
    Nerv::nerv_err_t ret;
    Py_BEGIN_ALLOW_THREADS
    ret = Nerv::nerv_object::create(_domain, _object_id);
    Py_END_ALLOW_THREADS
    return ret;
}

Nerv::nerv_err_t ::<xsl:value-of select="$class_name"/>::destroy()
{
    Nerv::nerv_err_t ret;
    Py_BEGIN_ALLOW_THREADS
    ret = Nerv::nerv_object::destroy();
    Py_END_ALLOW_THREADS
    return ret;
}

//
//
//
//
//
//

//
//
//
//
//
//

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">

            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="type='CALL'">
                <xsl:choose>
                  <xsl:when test="in_data='(null)' and out_data='(null)'">
Nerv::nerv_err_t ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>(Nerv::client_addr_t _client_addr, double _elapsed, double _limit)
{
    PyGILState_STATE state = PyGILState_Ensure();
    Nerv::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>")(_client_addr, _elapsed, _limit);
    PyGILState_Release(state);
    return ret_err;
}
                  </xsl:when>
                  <xsl:when test="in_data='(null)' and out_data!='(null)'">
Nerv::nerv_err_t ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>(Nerv::client_addr_t _client_addr, Nerv::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _ret_dat_, double _elapsed, double _limit)
{
    PyGILState_STATE state = PyGILState_Ensure();
    Nerv::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>")(_client_addr, boost::ref(_ret_dat_), _elapsed, _limit);
    PyGILState_Release(state);
    return ret_err;
}
                  </xsl:when>
                  <xsl:when test="in_data!='(null)' and out_data='(null)'">
Nerv::nerv_err_t ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>(Nerv::client_addr_t _client_addr, const Nerv::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _cal_dat_, double _elapsed, double _limit)
{
    PyGILState_STATE state = PyGILState_Ensure();
    Nerv::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>")(_client_addr, boost::ref(_cal_dat_), _elapsed, _limit);
    PyGILState_Release(state);
    return ret_err;
}
                  </xsl:when>
                  <xsl:when test="in_data!='(null)' and out_data!='(null)'">
Nerv::nerv_err_t ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>(Nerv::client_addr_t _client_addr, const Nerv::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _cal_dat_, Nerv::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _ret_dat_, double _elapsed, double _limit)
{
    PyGILState_STATE state = PyGILState_Ensure();
    Nerv::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>")(_client_addr, boost::ref(_cal_dat_), boost::ref(_ret_dat_), _elapsed, _limit);
    PyGILState_Release(state);
    return ret_err;
}
                  </xsl:when>
                </xsl:choose>
void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_cancel(Nerv::client_addr_t _client_addr, Nerv::nerv_err_t _error)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_cancel")(_client_addr, _error);
    PyGILState_Release(state);
}
              </xsl:when>
              <xsl:when test="type='SIGNAL'">
void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>(Nerv::client_addr_t _client_addr, <xsl:if test="in_data!='(null)'">const Nerv::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _sig_dat_,</xsl:if> double _elapsed)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>")(_client_addr, <xsl:if test="in_data!='(null)'">boost::ref(_sig_dat_),</xsl:if> _elapsed);
    PyGILState_Release(state);
}

void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_cancel(Nerv::client_addr_t _client_addr, Nerv::nerv_err_t _error)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_cancel")(_client_addr, _error);
    PyGILState_Release(state);
}
              </xsl:when>
              <xsl:when test="type='EVENT'">
Nerv::nerv_err_t ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_connect(Nerv::client_addr_t _client_addr, double _elapsed, double _limit)
{
    PyGILState_STATE state = PyGILState_Ensure();
    Nerv::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>_connect")(_client_addr, _elapsed, _limit);
    PyGILState_Release(state);
    return ret_err;
}

void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_shutdown(Nerv::client_addr_t _client_addr)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_shutdown")(_client_addr);
    PyGILState_Release(state);
}
              </xsl:when>
              <xsl:when test="type='COMMAND'">
Nerv::nerv_err_t ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_connect(Nerv::client_addr_t _client_addr, double _elapsed, double _limit)
{
    PyGILState_STATE state = PyGILState_Ensure();
    Nerv::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>_connect")(_client_addr, _elapsed, _limit);
    PyGILState_Release(state);
    return ret_err;
}

void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_shutdown(Nerv::client_addr_t _client_addr)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_shutdown")(_client_addr);
    PyGILState_Release(state);
}
                <xsl:choose >
                  <xsl:when test="in_data='(null)'">
void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_sync(Nerv::client_addr_t _client_addr, Nerv::sender_sync_model_t _sync_model, double _elapsed, double _limit)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_sync")(_client_addr, _sync_model, _elapsed, _limit);
    PyGILState_Release(state);
}
                  </xsl:when>
                  <xsl:otherwise>
void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_sync(Nerv::client_addr_t _client_addr, Nerv::sender_sync_model_t _sync_model, double _elapsed, double _limit, const Nerv::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _cmd_dat_)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_sync")(_client_addr, _sync_model, _elapsed, _limit, boost::ref(_cmd_dat_));
    PyGILState_Release(state);
}
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:when test="type='INFORMATION'">
Nerv::nerv_err_t ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_connect(Nerv::client_addr_t _client_addr, bool _tcp_request, double _elapsed, double _limit)
{
    PyGILState_STATE state = PyGILState_Ensure();
    Nerv::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>_connect")(_client_addr, _tcp_request, _elapsed, _limit);
    PyGILState_Release(state);
    return ret_err;
}

void ::<xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_shutdown(Nerv::client_addr_t _client_addr)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_shutdown")(_client_addr);
    PyGILState_Release(state);
}
              </xsl:when>
              <xsl:when test="type='BROADCAST'">
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
</xsl:template>

</xsl:stylesheet>





