<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/><xsl:param name = "save_path" />
<xsl:param name = "xml_path" />
<!-- TODO : xalan 을 이용하는 배치파일을 만든다. 컴포넌트.xml + excute_xalan = 컴포넌트.bat = 헤더파일 + 소스파일 + cmake 파일 + 등등..... --><!-- xalan -o "c:\dev/ncgen.bat" -p save_path "'c:\dev'" "c:\dev\ai data.xml" "./xsl/excute_xalan.xsl" -->
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
<xsl:text/>#!/bin/bash

<xsl:for-each select="nerv_icde/datadomain/row">
mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv/src/include/Nerv/Data<xsl:value-of select="path"/>"<xsl:text/>
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/src/include/Nerv/Data<xsl:value-of select="path"/>/<xsl:value-of select="name"/>.h" -p export_data_domain_path "'<xsl:value-of select="path"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/include/Nerv/Data/data_domain_h.xsl"<xsl:text/>
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/src/include/Nerv/Data<xsl:value-of select="path"/>/<xsl:value-of select="name"/>_export.h" -p export_data_domain_path "'<xsl:value-of select="path"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/include/Nerv/Data/data_domain_export_h.xsl"<xsl:text/>
  <xsl:variable name="path" select="path"/>
  <xsl:for-each select="data/row">
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/src/include/Nerv/Data<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.h" -p export_data_domain_path "'<xsl:value-of select="$path"/>'" -p export_data_name "'<xsl:value-of select="name"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/include/Nerv/Data/data_domain_data_h.xsl"<xsl:text/>
  </xsl:for-each>
</xsl:for-each>

cp "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/include/Nerv/Data/sizeof.h" "<xsl:value-of select="$save_path"/>/py_nerv/src/include/Nerv/Data/."
cp "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/include/Nerv/Data/copy.hpp" "<xsl:value-of select="$save_path"/>/py_nerv/src/include/Nerv/Data/."

<xsl:for-each select="nerv_icde/methoddomain/row">
mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv/src/include/Nerv/Method<xsl:value-of select="path"/>"
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/src/include/Nerv/Method<xsl:value-of select="path"/>/<xsl:value-of select="name"/>.h" -p export_method_domain_path "'<xsl:value-of select="path"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/include/Nerv/Method/method_domain_h.xsl"
</xsl:for-each>

<xsl:for-each select="nerv_icde/component/proxy_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv/src/Nerv/Proxy/<xsl:value-of select="class_name"/>"
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/src/Nerv/Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.h" -p export_proxy_class_id "'<xsl:value-of select="id"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/Nerv/Proxy/proxy_class_h.xsl"
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/src/Nerv/Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cpp" -p export_proxy_class_id "'<xsl:value-of select="id"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/Nerv/Proxy/proxy_class_cpp.xsl"
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/src/Nerv/Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>_export.h" -p export_proxy_class_id "'<xsl:value-of select="id"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/Nerv/Proxy/proxy_class_export_h.xsl"
</xsl:for-each>

<xsl:for-each select="nerv_icde/component/stub_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv/src/Nerv/Stub/<xsl:value-of select="class_name"/>"
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/src/Nerv/Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.h" -p export_stub_class_id "'<xsl:value-of select="id"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/Nerv/Stub/stub_class_h.xsl"
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/src/Nerv/Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cpp" -p export_stub_class_id "'<xsl:value-of select="id"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/Nerv/Stub/stub_class_cpp.xsl"
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/src/Nerv/Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>_export.h" -p export_stub_class_id "'<xsl:value-of select="id"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/Nerv/Stub/stub_class_export_h.xsl"
</xsl:for-each>

xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/src/py_nerv.cpp" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/src/py_nerv_cpp.xsl"

mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv/build"
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/build/CMakeLists.txt" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/build/CMakeLists.xsl"
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv/build/cmake_clean" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv/build/cmake_clean_sh.xsl"

<xsl:for-each select="nerv_icde/component/proxy_list/row">
xalan -o "<xsl:value-of select="$save_path"/>/<xsl:value-of select="class_name"/>.py" -p export_proxy_class_id "'<xsl:value-of select="id"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/class_proxy_py.xsl"
</xsl:for-each>

<xsl:for-each select="nerv_icde/component/stub_list/row">
xalan -o "<xsl:value-of select="$save_path"/>/<xsl:value-of select="class_name"/>.py" -p export_stub_class_id "'<xsl:value-of select="id"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/class_stub_py.xsl"
</xsl:for-each>

xalan -o "<xsl:value-of select="$save_path"/>/<xsl:value-of select="$component_name"/>.py" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/component_py.xsl"

xalan -o "<xsl:value-of select="$save_path"/>/py_nerv_print_data.py" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv_print_data.xsl"
xalan -o "<xsl:value-of select="$save_path"/>/py_nerv_set_data.py" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/makepnc4/xsl/py_nerv_set_data.xsl"


</xsl:template>


</xsl:stylesheet>
